import React, { Dispatch, SetStateAction } from "react";
interface IRequestStruct {
    getSizeAPI: string;
    getSizeParams: object;
    chunkDownloadAPI: string;
    chunkDownloadParams: object;
}
interface IProps extends Omit<React.HTMLAttributes<HTMLDivElement | HTMLButtonElement>, 'prefix'> {
    reqSetting: IRequestStruct;
    fileName: string;
    mime: string;
    size: number;
    concurrency: number;
    setStatus: Dispatch<SetStateAction<number | undefined>>;
    setPercent: Dispatch<SetStateAction<number | undefined>>;
}
/**
 *
 * @param reqSetting
 * 相关接口地址与参数(getSizeAPI: 用于获取文件的大小，确定发送请求的个数；getSizeParams: 获取文件大小接口的参数；chunkDownloadAPI: 分片下载；chunkDownloadParams: 分片下载接口的参数)
 * @param fileName
 * 需要保存为什么名字的文件
 * @param mime
 * 文件的类型
 * @param size
 * 分片大小（单位兆-M）
 * @param concurrency
 * 下载文件的并发线程数
 * @param setStatus
 * 设置当前状态（1：获取文件大小出现错误；2: 下载切片出现错误；）
 * @param setPercent
 * 文件上传进度（0-100）
 *
 */
export default function ChunksDownload(props: IProps): JSX.Element;
export {};
